*******************************************************************************
*************** 				VERSION 2.3.16					***************
*******************************************************************************

New Features

[ECARS-2266] - If the user starts checks without selecting a dataset, a message must inform him/her
[ECARS-2271] - Include process status in validation run metadata (i.e. "validation_run.csv")
[ECARS-2283] - Update W-TNME rule for Stage analysis
[ECARS-2068] - Add accessiblity statement in QCS
[ECARS-2315] - Update W-TNME rule for Stage analysis
[ECARS-2343] - Update TNM yaml config files for Stage analysis
[ECARS-2368] - Add a ErrorCodeMapperRule mapping error code into Survival labels
[ECARS-2365] - Add column MESSAGE_ID to PROTOCOL_TO_RULE table

Improvements

[ECARS-2243] - Update New rule W-SUDA for Survival analysis
[ECARS-2244] - Update- User documentation for new release QCS 2.3.1
[ECARS-2239] - Implement new functionality to stop validation process
[ECARS-2280] - QCS 2.3.2: a message blocks the app when starting the validation
[ECARS-2286] - Update rule W-MOTO: add new condition
[ECARS-2288] - Update logic of W-MISS for staging variables
[ECARS-2289] - Update logic of W-UNKN for staging variables
[ECARS-2290] - Update Mortality protocol 2022 "Age Unit" (5 var)
[ECARS-2291] - Update Mortality protocol 2022 "Age Range" (5 var)
[ECARS-2292] - Update the name of all protocols in the QCS GUI
[ECARS-2278] - New rule W-ASMI for Stage analysis
[ECARS-2281] - New rule W-SSMI for Stage analysis
[ECARS-2282] - New rule W-TOST for Stage analysis
[ECARS-2300] - Update range of variable year of birth (YoB)
[ECARS-2301] - Update range of variable year of incidence (YoI)
[ECARS-2302] - Update range of variable year of followup (YoF)
[ECARS-2303] - Update range of variable survival time (Surv_time)
[ECARS-2305] - Update rule W-BDMO
[ECARS-2276] - Rule E-OUTR for TNM staging variables: update allowed cT,pT values
[ECARS-2277] - Rule E-OUTR for TNM staging variables: update allowed cN,pN values
[ECARS-2298] - Update W-SUMU for Survival study
[ECARS-2306] - Update logic of E-MISS for some variables
[ECARS-2307] - Apply logic W-UNKN to variable Age
[ECARS-2308] - Update rule E-AGEC: add new condition
[ECARS-2309] - New rule E-AUBS for Survival analysis
[ECARS-2312] - Disable rule W-ASMI for Stage analysis
[ECARS-2313] - Update rule W-SSMI for Stage analysis
[ECARS-2314] - Update rule W-TOST for Stage analysis
[ECARS-2319] - Implement full tab navigation in QCS GUI
[ECARS-2224] - Update document instructions for running in background
[ECARS-2335] - Add column "enabled" to PROTOCOL_TO_RULE table
[ECARS-2336] - New rule W-SUBA for Survival analysis
[ECARS-2339] - Disable previous rule E-AUBS
[ECARS-2352] - Update rule W-SUDA: update the allowed interval in days for variable survival time
[ECARS-2355] - Improve reports with the detailed list of occurrences for variables that triggered univariant error/message
[ECARS-2366] - Refactor legacy reports detailed summary (needs to improve performances)
[ECARS-2369] - Update rule W-SUBA for Survival analysis
[ECARS-2381] - Remove description of disabled rule E-AUBS
[ECARS-2372] - Update rule W-BDpM: check only Beh 3 and add BoD 5
[ECARS-2373] - Update rule W-BDpN: check only Beh 3 and add BoD 5 and 6
[ECARS-2374] - Update rule W-BDpT: check only Beh 3 and add BoD 5 and 6
[ECARS-2377] - Update W-BTNM rule
[ECARS-2378] - Update rule W-SSMI to check only behaviour 3
[ECARS-2379] - Update rule W-TNMM to check only behaviour 3
[ECARS-2380] - Update rule W-TNMS to check only behaviour 3
[ECARS-2387] - Update range of allowed values for variables pT and cT
[ECARS-2388] - Update range of allowed values for variables pN and cN
[ECARS-2389] - Update range of allowed values for variables pM and cM
[ECARS-2390] - Update rule W-TOST for Stage analysis
[ECARS-2392] - Update E-CoDA rule
[ECARS-2395] - Update E-CoDA rule (handle case YoB > YoI)
[ECARS-2399] - Update W-TNME rule for Stage analysis
[ECARS-2400] - Update range of allowed values for variables Stage
[ECARS-2402] - Do not applicate rule W-TNMS for values of TOS
[ECARS-2403] - Update rule W-SSMI for Stage analysis
[ECARS-2404] - Update user compendium in the Doc folder
[ECARS-2409] - Add column REPORT to RuleOutput
[ECARS-2412] - Delete temp sub folders after each run
[ECARS-2416] - Update column ERROR_DESCRIPTION of qcs_rule_output_x.csv
[ECARS-2420] - Rule W-TNMS: update TNM yaml config files edition 7,8
[ECARS-2421] - Update logic of W-UNKN for variable Grade
[ECARS-2430] - Improve rule W-TNMS
[ECARS-2436] - Disable check of W-UNKN on Grade for next public release
[ECARS-2345] - Update QCS license (TXT file and header of Java files)
[ECARS-2443] - Bug in rule W-TNMS for specific topography codes
[ECARS-2451] - Bug in rule W-TNMS for specific topography codes
[ECARS-2470] - Update field size of variable Stage
[ECARS-2471] - Update range of allowed values for variables Stage
[ECARS-2472] - Update range of allowed values for variables pT and cT
[ECARS-2473] - Update range of allowed values for variables pN and cN
[ECARS-2480] - Configure all univariant rules using explict entries in RULE_TO_FIELD
[ECARS-2481] - Update Mortality-Age Unit protocol: change name of variables
[ECARS-2482] - Update Mortality-Age Range protocol: change name of variables
[ECARS-2483] - Update Population-Age Unit protocol: change name of variables
[ECARS-2484] - Update Population-Age Range protocol: change name of variables
[ECARS-2485] - Update Life table protocol: change name of variables
[ECARS-2487] - Include updated QSC user compendium 2.3.16 in QCS docs folder

Fixed Bugs

[ECARS-1160] - If any report is opened, the new reports are not generated
[ECARS-2246] - Export of SQL commands generates wrong log files
[ECARS-2261] - Rule E-OUTR: wrong output for the pN variable
[ECARS-2279] - QCS not working on a population file for Latvia CR
[ECARS-2375] - Problem with rule W-TNMM (wrongly returned)
[ECARS-2410] - When temp folder is empty, QCS does not start validation
[ECARS-2413] - QCS stucks when running the second time on Belgium dataset
[ECARS-2417] - GUI processing statistics: wrong "Total number of messagges"
[ECARS-2424] - Bug in rule W-TNMS

Technical Tasks

[ECARS-2199] - Update QCS dependencies(deal with security issues)
[ECARS-2235] - Implement feature allowing dump of SQL DDL configuration
[ECARS-2332] - Publish QCS source code on public repo

*******************************************************************************
*************** 				VERSION 2.3				        ***************
*******************************************************************************

New Features

[ECARS-1979] - Implement example of a "script client" of the daemon feature
[ECARS-1904] - Implement daemon feature for QCS
[ECARS-2201] - New rule W-SUMU for Survival analysis
[ECARS-2202] - New rule W-SUDA for Survival analysis
[ECARS-2230] - Add metadata information storing DB version

Improvements

[ECARS-2221] - Update Options titles in the QSC GUI
[ECARS-2205] - Update config files for rule W-TNMS
[ECARS-2193] - Update config files for rule W-BDMO
[ECARS-2096] - Update config file for variable Topography
[ECARS-2058] - Update rules W-BEGR and W-TBGR
[ECARS-2055] - Migrate test-suite from external repo to main QCS repo
[ECARS-2033] - Update config files for rule W-MOTO
[ECARS-2027] - Update config file for rules W-MOGR
[ECARS-2026] - Update config files for rule W-MOTO
[ECARS-2024] - Enhance implementation of W-UNKN for survival
[ECARS-2023] - Update conditions for error E-AUVS
[ECARS-2021] - Update conditions for error E-BDVS
[ECARS-2020] - Update conditions for error E-VSBD
[ECARS-2019] - Remove the W-AGMT flag from options panel
[ECARS-2018] - Update logic of W-MISS (for survival)
[ECARS-2009] - Update range definitions to year 2025 (E-OUTR)
[ECARS-1991] - Update logic of E-MISS
[ECARS-1941] - Update logic of W-MISS
[ECARS-1940] - Update config file for rules W-MOGR
[ECARS-1933] - Update logic of W-UNKN
[ECARS-1849] - Do not apply any ENCR exception if sub-bunches have records in common (partially developed)
[ECARS-1830] - Update config files for multiple primary tumours
[ECARS-1803] - Update W-BDMS rule
[ECARS-1799] - Update config file range_data_5.txt for variable pT and cT
[ECARS-1791] - Duplicates in groups of Multiple Primary tumours (W-MPCR and MPMT)
[ECARS-1705] - Remove deprecated, obsolete or legacy unused DAO components
[ECARS-1695] - Improve W-TNMS rule: TNM tables with alphanumeric TNM values
[ECARS-1411] - Improve W-TNMS logic for T and N variables (partially developed)
[ECARS-2021] - Update conditions for error E-BDVS
[ECARS-2209] - Update range of allowed values for variables pT and cT
[ECARS-2210] - Update range of allowed values for variables pN, cN
[ECARS-2211] - Update range of allowed values for variables pM, cM
[ECARS-2232] - User documentation for new release QCS 2.3
[ECARS-2233] - Include new QSC user compendium 2.3 in docs folder
[ECARS-2234] - Add a reference to the DB version the output reports

Fixed Bugs

[ECARS-1995] - Fix fallback feature of QCS DB
[ECARS-1833] - Wrong classifcation of W-MPMT records with overlapping morphology code (not a bug)
[ECARS-1605] - Wrong W-MPCR assigned to a combination of solid/haematoogical MPs: Exception4
[ECARS-2200] - Open button in QSC GUI does not work
[ECARS-2229] - Rename OLD pdf file

Technical Tasks

[ECARS-1766] - Add header on each file mentioning QCS License
[ECARS-1738] - Remove properties files from DAO pattern
[ECARS-1734] - Complete TODO tasks in the DAO layer
[ECARS-641]  - Manage execution moods from command line

*******************************************************************************
*************** 				VERSION 2.2.8					***************
*******************************************************************************

Improvements

[ECARS-1802] - User documentation for new release QCS 2.2.8
[ECARS-1786] - Check reason of C-SKIP error for Grade and Morphology rule
[ECARS-1783] - Update config file with definition of MP groups
[ECARS-1781] - QCS stucks for some big files (reason: wrong Java installation)
[ECARS-1777] - Update W-MOGR rule with new CNS Beh 3 using the key topography
[ECARS-1769] - Update W-MOGR rule for HM ans solid tumours
[ECARS-1738] - Remove properties files from DAO pattern
[ECARS-1704] - Update QCS License (to support JPA)

Fixed Bugs

[ECARS-1797] - E-FORM rule: issue in checking range value for variable pN
[ECARS-1785] - Duplicates in a bunch of W-MPCR records
[ECARS-1784] - Bug in reading config file of MP groups: Exception 4
[ECARS-1782] - QCS's BAT file should search first JDK, than JRE
[ECARS-1776] - Configuration of validation rules data is read only from JAR
[ECARS-1774] - Fix bug on rules W-MPMT and W-MPCR

Technical Tasks

[ECARS-1768] - Check definition of Grade range
[ECARS-1734] - Complete TODO tasks in the DAO layer
[ECARS-1553] - Complete refactoring of ENCR cross-field rules
[ECARS-1373] - Restore integrity check of application configuration (legacy configuration)

*******************************************************************************
*************** 				VERSION 2.2.2					***************
*******************************************************************************

Improvements and fixed bugs

[ECARS-1733] - Improve feedback to user during pre-record cycle
[ECARS-1732] - QCS 2.2 stucks when producing PDF report for big files

*******************************************************************************
*************** 				VERSION 2.2						***************
*******************************************************************************

Improvements

[ECARS-1727] - Update the list of allowed topography values
[ECARS-1722] - Update W-MOTO rule
[ECARS-1721] - Update W-BDMO rule removing Morphos for BoD = 1
[ECARS-1720] - Update topography groups for checking multiple primaries
[ECARS-1718] - Update W-TBGR rule for CNS
[ECARS-1715] - Update rule W-SUpT: check BoD
[ECARS-1714] - Update W-MOGR rule with new CNS Beh 3
[ECARS-1709] - Update W-TBGR rule with new CNS morphologies/grade
[ECARS-1706] - Update W-MOTO rule with ICD-O-3.2
[ECARS-1698] - Improve W-SUpT rule (add autopsy variable)
[ECARS-1690] - Update logic of W-TNMS: TNM tables with alphanumeric Stage
[ECARS-1684] - Update configuration file for W-BEGR (Table 5)
[ECARS-1670] - Improve selection of Java on NET1 laptops (BAT files)

Technical Tasks

[ECARS-1696] - Write JPA Repository to implement new DAO concrete classes
[ECARS-1691] - Test inclusion of JPA to access database

Fixed Bugs

[ECARS-1726] - Fix bug for W-TBGR rule
[ECARS-1725] - Fix bug for W-AGMT rule (wrong age match)
[ECARS-1724] - Correct config file for W-AGMT rule
[ECARS-1710] - Fix issue in MP check (valid records)
[ECARS-1693] - Fix wrong extraction of numeric stage value
[ECARS-1681] - QCS stucks for dataset with missing patient id
[ECARS-1667] - Restored access to configuration files in rules folder

*******************************************************************************
*************** 				VERSION 2.1.2					***************
*******************************************************************************

Improvements

[ECARS-1648] - Obsolete use of "9" to identify unknown value in fields
[ECARS-1674] - Remove duplicate messages for W-BDpM
[ECARS-1676] - Update list of allowed topography codes
[ECARS-1679] - Update user compendium

Fixed Bugs

[ECARS-1677] - Fix runtime issues on macOS (license key)

Technical Tasks

[ECARS-1630] - LISO assignement for QCS 2.1
[ECARS-1673] - Remove demo mode: if user does not accept license -> quit
[ECARS-1675] - Update content on license panels (and minor changes)
[ECARS-1678] - Disable "Initialization panel" when changing protocol

*******************************************************************************
*************** 				VERSION 2.1.1					***************
*******************************************************************************

New Features

[ECARS-1654] - New output summary file

Improvements

[ECARS-1653] - Update the list of allowed validation protocols
[ECARS-1655] - Update description of rule W-SEMO
[ECARS-1657] - Update description of rule W-SEMO
[ECARS-1658] - Update messages in the GUI at the end of validation
[ECARS-1663] - Update messages in the GUI when selecting a protocol
[ECARS-1664] - Update morphology groups for checking multiple primaries
[ECARS-1665] - Update documents in docs folder
[ECARS-1666] - Update the name of the QCS folder in the QCS Kit

*******************************************************************************
*************** 				VERSION 2.1						***************
*******************************************************************************

New Features

[ECARS-1326] - New error E-AUVS (aka E-VSAU)
[ECARS-1327] - New error E-VSBD
[ECARS-1328] - New error E-BDVS
[ECARS-1401] - MPMT Exception 1
[ECARS-1403] - MPMT Exception 2
[ECARS-1404] - MPMT Exception 3
[ECARS-1443] - Split W-MPMT warning in two different messages
[ECARS-1465] - New case for E-MPMT (unspecified and specified morphologies for 2nd MP criterion)
[ECARS-1470] - Refactor engine and report module in order to show MP matching records
[ECARS-1474] - Update protocols for MORTALITY, LIFE TABLE and POPULATION files
[ECARS-1496] - New Mortality protocols for ENCR data Call (2020-22)
[ECARS-1498] - New Population protocols for ENCR data Call (2020-22)
[ECARS-1503] - MPMT Exception 4
[ECARS-1527] - MPMT Exception 1 to be update with respect of behaviour
[ECARS-1542] - New Basis of Diagnosis check (Table 4)
[ECARS-1550] - New rule about Table-5, with code W-TBGR
[ECARS-1627] - Add panel for accepting QCS license

Improvements

[ECARS-1188] - Refactor reused ENCR 2014 cross-field rules
[ECARS-1362] - Updated rule for the Multiple Primary check (W-MPMT)
[ECARS-1446] - Trim leading and trailing quotes from input data
[ECARS-1461] - Apply "MP Exceptions" only on solid tumours
[ECARS-1462] - Update behaviour conditions for the Multiple Primary check
[ECARS-1468] - Update pM and cM ranges as requested by Mohsen (CH)
[ECARS-1469] - Update definition pattern of all MP Exceptions
[ECARS-1475] - Updated Morphology values for the Multiple Primary check (2022)
[ECARS-1481] - Update Morphology values for the Multiple Primary check (2022)
[ECARS-1509] - Improve W-MPMT assignment to records with unspecified morphology
[ECARS-1517] - Refactor rule W-AGMT
[ECARS-1519] - Update of the config file TNMRuleEdition8.yaml
[ECARS-1522] - Refactor DAO architecture in order to switch to Quarkus
[ECARS-1523] - Update behaviour conditions for the Multiple Primary check
[ECARS-1529] - Rename E-MPMT and W-MPMT error codes
[ECARS-1534] - Change Topography sintax from 3 chars to 4 chars in MP config files
[ECARS-1535] - Change Morpholgy values used by MP config files
[ECARS-1536] - Update behaviour conditions for the MP check
[ECARS-1524] - Remove reference to the QC report in description of W-TNMS
[ECARS-1543] - Change range of BoD (2023)
[ECARS-1546] - Update rule W-AGMT to criteria for quality report 2023 (Table 2)
[ECARS-1547] - Update configuration files for W-MOTO (2023)
[ECARS-1548] - Update configuration files for W-MOGR (2023)
[ECARS-1549] - Add new configuration files for rule W-BEGR (new Table 5)
[ECARS-1552] - Update description of rule W-AGMT
[ECARS-1553] - Complete refactoring of ENCR cross-field rules
[ECARS-1558] - Update logic of W-BEGR (new Table 5)
[ECARS-1562] - Update logic of W-BEGR (new Table 5)
[ECARS-1560] - Update Morphology/Behaviour config file
[ECARS-1561] - Update range of allowed values for BoD
[ECARS-1566] - Update description of message E-SETO
[ECARS-1567] - Update range of allowed values for TNM Edition
[ECARS-1570] - Update rule W-BDpN
[ECARS-1571] - Update rule W-BDpM
[ECARS-1584] - Update description of rule W-BTNM
[ECARS-1588] - Update config file for rule W-BEGR (new Table 5)
[ECARS-1589] - Update range of values allowed for Grade
[ECARS-1596] - Change name of unit F1 in QCS panels
[ECARS-1597] - Update behaviour conditions for the MP check
[ECARS-1598] - Update range of values allowed for Stage
[ECARS-1614] - Mortality/Population files: update config file to allow variable name "Age unit"
[ECARS-1615] - Update list of NUTS codes used for variable Geo_code
[ECARS-1616] - Update config file with allowed values for variable ToS
[ECARS-1617] - New rule W-SUBD
[ECARS-1618] - New rule W-SUpT
[ECARS-1624] - Update config file for rule W-AGMT
[ECARS-1632] - Rule W-BDMO update config file for BoD=0
[ECARS-1634] - Update rule W-BDpM
[ECARS-1635] - Update configuration files for W-MOTO (2023)
[ECARS-1637] - Add check on Stage variable for W-BTNM rule
[ECARS-1638] - Update description for rule W-BEGR
[ECARS-1646] - Rule W-SUBD not applied correctly
[ECARS-1647] - Refactor GUI panels handling QCS license

Fixed Bugs

[ECARS-1194] - Rule W-AGMT not working through Java Launcher
[ECARS-1445] - Error in splitting records in sections E_MPMT and W-MPMT with QCS 2.0.1
[ECARS-1447] - Critical error during valition (missing PAT column)
[ECARS-1477] - Open button does not open the correct protocol's folder
[ECARS-1479] - Maven build is duplicating config folders
[ECARS-1480] - Log4j configuration file is not loaded from external configuration
[ECARS-1508] - Wrong W-MPMT assigned
[ECARS-1513] - Duplicate rule not working for some dataset
[ECARS-1514] - Creation of reports crashes when dataset contains a comma
[ECARS-1515] - Floating datatype is not checked by DataTypeRule
[ECARS-1516] - Rule W-ETNC does not work (maybe for wrong E-OUTR message)
[ECARS-1500] - Warning W-TNMM is wrongly rised for some records
[ECARS-1510] - Wrong W-MPMT assigned - Violation of Exception 1
[ECARS-1520] - Wrong W-TNMM warnings rise after updating TNM8 config file
[ECARS-1463] - Investigate MP bugs triggered by dataset MPMT_test_E4_mf
[ECARS-1544] - New W-MPCR messages are not produced for some records
[ECARS-1557] - Some MPMTs not recognised: old W-MPMT/new W-MPCR not produced for some records
[ECARS-1559] - Exception 1 not applied for combination C569, 8010
[ECARS-1568] - Wrong W-TNMS produced for Stage = 4b
[ECARS-1585] - Wrong W-MPCR assigned - Violation of Exception 4
[ECARS-1586] - Wrong W-MPMT assigned to haematological MPs
[ECARS-1607] - Wrong W-MPMT assigned - Violation of Exception 4
[ECARS-1609] - Wrong records assigned to rule E-DUPL
[ECARS-1611] - Violation of Exception 2 (MPMT)
[ECARS-1622] - Wrong application of rule E-BDVS
[ECARS-1623] - Wrong E-HEAD message in Mortality, Life Table and Population protocols
[ECARS-1625] - Missing E-FORM and E-OUTR messages in Mortality and Population protocols
[ECARS-1633] - Rule W-BDMO update config file for BoD=1
[ECARS-1636] - Wrong W-TNMS message
[ECARS-1641] - QCS does not start on NET1 (licence issue)
[ECARS-1644] - Wrong W-SUpT message

Technical Tasks

[ECARS-1417] - Preparation of deliverable (QCS 2.0.x)
[ECARS-1418] - Formatting and documentation (QCS 2.0.x)
[ECARS-1444] - Synchronize test-suite with new PMs logic
[ECARS-1459] - Clarify definition of hematological malignancies
[ECARS-1460] - Verify if MPMT Exceptions need hematological pre-condition
[ECARS-1649] - Update documents in docs folder
[ECARS-1645] - Publish QCS deliverable on public repo (Frontiers)
[ECARS-1649] - Update documents in docs folder

Use Cases

[ECARS-527]  - Overview of the content of the output text report
[ECARS-1138] - Additional checks on the extent of the disease - 9 (W-ETNC)
